#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <string.h>

static char history[1000][512];
static char buff[512];



static void redraw_buff(int curr_cmd)
{
  int i;

  printf("\r");
  for (i=0; i<50; i++) 
   printf(" ");
  printf("\r");
  printf("<myshell:%d> %s", curr_cmd, buff); fflush(0);
}


int main()
{
 int curr_history = 0;
 int curr_pos = 0;
 int curr_cmd = 0;
  char ch;
  struct termios save_termios;
  int curr_h=0;

  if (tcgetattr(STDIN_FILENO, &save_termios) < 0) /* get whatever is there */
    perror("getattr");

  save_termios.c_lflag &= ~(ECHO | ICANON); /* set non canonical mode, turn of echoing */

  save_termios.c_cc[VMIN] = 0; /* Read will return 0 immediately, if no data is ...*/
  save_termios.c_cc[VTIME] = 0;  /*... available. Otherwise it reads available data. */

  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &save_termios) < 0) 
    perror("setattr");
  
  
  printf("<myshell:%d> ", curr_cmd);fflush(0);
  while (1) 
  {    
    if (read(STDIN_FILENO, &ch, 1) > 0) 
    {
      switch(ch)
      {
      case '\n':
	putchar(ch);
        buff[curr_pos] = '\0';
	printf("buf = %s\n", buff);
        strcpy(history[curr_history++], buff);
        curr_h = curr_history;
        curr_cmd++;
        printf("<myshell:%d> ", curr_cmd);fflush(0);
        curr_pos = 0;
	break;
      case 1: /* ctrl-A */
        if (curr_pos > 0) 
	{
	  buff[--curr_pos] = '\0';
	  redraw_buff(curr_cmd);
	}
	break;
      case 16: /* ctrl-P */
        if (curr_h > 0) 
	{
	  strcpy(buff, history[curr_h-1]);
	  curr_h--;
	  curr_pos = strlen(buff);
          redraw_buff(curr_cmd);
	}
	break;
      default:
	buff[curr_pos++] = ch;
        putchar(ch); fflush(0);
	break;
      }
    }
  }

  return 0;
}








